//Bf2 Rank Mod forwards File
//Contains all the standard forwarded functions

#if defined bf2_forward_included
#endinput
#endif
#define bf2_forward_included

public plugin_precache()
{
	new tempSound[64];
	formatex(tempSound, charsmax(tempSound), "sound/%s", gSoundRank);
	if ( !file_exists(tempSound) )
	{
		copy(gSoundRank, charsmax(gSoundRank), "buttons/bell1.wav");
	}
	
	formatex(tempSound, charsmax(tempSound), "sound/%s", gSoundBadge);
	if ( !file_exists(tempSound) )
	{
		copy(gSoundBadge, charsmax(gSoundBadge), "fvox/bell.wav");
	}
	
	precache_sound(gSoundRank);
	precache_sound(gSoundBadge);
	precache_model("models/w_medkit.mdl");
	
	new bool:error = false;
	new spriteFile[26];
	
	for ( new counter; counter < MAX_RANKS+5; counter++)
	{
		spriteFile[0] = '^0';
		formatex(spriteFile, charsmax(spriteFile), "sprites/bf2rankspr/%d.spr", counter);
		
		//Done this way so that a message is logged for each missing file
		if ( !file_exists( spriteFile ) )
		{
			log_amx("[ERROR] Brakujacy plik sprite: ^"%s^"", spriteFile);
			error = true;
		}
		else {
			gSprite[counter] = precache_model(spriteFile);
		}
	}
	
	g_healspr = engfunc(EngFunc_PrecacheModel, sprite_heal)
	
	if ( error )
	{
		set_fail_state("Brakuje plikow sprite , zaladowanie pluginu niemozliwe! Sprawdz Logi AMXX");
	}
}

public plugin_cfg()
{
	get_configsdir(configsdir, charsmax(configsdir));
	
	//SQL
	#if defined SQL
	SQLenabled = false;
	sql_init();
	#else
	vault_init();
	#endif
	
	set_cvar_string("bf2_version", gWersjaPluginu);
	
	if ( gPlayerName != -1 && get_xvar_num(gPlayerName) )
	{
		log_amx("miscstats.amxx ^"PlayerName^" opcja jest wlaczona, BF2 aim info nie bdzie pokazywane.");
	}
	
	//set_task(10.0, "ranking_officer_disconnect");
}

public client_putinserver(id)
{
	// Find a czero bot to register Ham_Spawn
	if ( !gCZBotRegisterHam && gPcvarBotQuota && get_pcvar_num(gPcvarBotQuota) > 0 && is_user_bot(id) )
	{
		// Delay for private data to initialize
		set_task(0.1, "RegisterHam_CZBot", id);
	}
	
	g_imobile[id] = false;
	newplayer[id] = true;
	gStatsLoaded[id] = 0;
	
	get_save_key(id);
	
	if (!get_pcvar_num(gPcvarWymus))
	{
		client_cmd(id,"hud_centerid 0");
		client_cmd(id,"cl_shadows 0"); 
		set_task(20.0, "Announcement", id);
	}
	else
	{
		set_task(20.0, "Announcement", id);
	}
	#if defined NOWY_HUD
	RemoveHUD(id)
	#endif
}

public client_disconnect(id)
{
	save_badges(id);
	
	if ( id == highestrankid )
	{
		set_task(2.0, "ranking_officer_disconnect");
	}
	
	clear_stat_globals(id);
	gStatsLoaded[id] = 0;
	
	g_silent[id] = false
	#if defined NOWY_HUD
	RemoveHUD(id)
	#endif
}

public PlayerPreThink(id)
{
	if(is_user_alive(id)) 
	{
		if (g_PlayerBadges[id][BADGE_SMG])
			return FMRES_HANDLED;
			
		new Float:fVector[3];
		pev(id, pev_velocity, fVector)
		new Float: fSpeed = floatsqroot(fVector[0]*fVector[0]+fVector[1]*fVector[1]+fVector[2]*fVector[2])
		if((fm_get_user_maxspeed(id) * 5) > (fSpeed*9))
		{
			set_pev(id, pev_flTimeStepSound, 300)
		}

	}	
	
	if (g_PlayerBadges[id][BADGE_AGENT]<LEVEL_VETERAN || !is_on_knife[id])
		return FMRES_IGNORED;
	
	if (entity_get_int(id, EV_INT_button) & 2)
	{
		new flags = entity_get_int(id, EV_INT_flags)
		
		if (flags & FL_WATERJUMP)
			return FMRES_IGNORED;
		if ( entity_get_int(id, EV_INT_waterlevel) >= 2 )
			return FMRES_IGNORED;
		if ( !(flags & FL_ONGROUND) )
			return FMRES_IGNORED;
		
		new Float:velocity[3]
		entity_get_vector(id, EV_VEC_velocity, velocity)
		velocity[2] += 250.0
		entity_set_vector(id, EV_VEC_velocity, velocity)
		
		entity_set_int(id, EV_INT_gaitsequence, 6)
	}
	return FMRES_IGNORED;
}

public plugin_end()
{
	server_save();
	
	#if defined SQL
	if ( SQLenabled )
	{
		//Free the handle thingy..
		SQL_FreeHandle(g_SqlTuple);
	}
	#else
	new pruneDelay = (NEGATIVE_SECONDSINDAY * get_pcvar_num(gPcvarPruneDays));
	if ( pruneDelay < 0 )
	{
		nvault_prune(g_Vault, 0, get_systime(pruneDelay));
	}
	
	nvault_close(g_Vault);
	#endif
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
